---
title: FileSystemFileEntry.file()
slug: Web/API/FileSystemFileEntry/file
tags:
  - API
  - File
  - File System API
  - File and Directory Entries API
  - FileSystemFileEntry
  - Files
  - Method
  - Non-standard
  - Reference
---
<p>{{APIRef("File System API")}}{{SeeCompatTable}}</p>

<p>The {{domxref("FileSystemFileEntry")}} interface's method <code><strong>file</strong></code><strong><code>()</code></strong> returns a {{domxref("File")}} object which can be used to read data from the file represented by the directory entry.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>FileSystemFileEntry</em>.file(<em>successCallback</em>[, <em>errorCallback</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>successCallback</code></dt>
 <dd>A callback function which is called when the {{domxref("File")}} has been created successfully; the <code>File</code> is passed into the callback as the only parameter.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>If provided, this must be a method which is called when an error occurs while trying to create the {{domxref("File")}}. This callback receives as input a {{domxref("FileError")}} object describing the error.</dd>
</dl>

<div class="note">
<p>Editor's note: We need to find out what kinds of errors can occur and document them.</p>
</div>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Example">Example</h2>

<p>This example establishes a method, <code>readFile()</code>, reads a text file and calls a specified callback function with the received text (in a {{jsxref("String")}} object) once the read is completed. If an error occurs, a specified (optional) error callback is called.</p>

<pre class="brush: js">function readFile(entry, successCallback, errorCallback) {
  entry.file(function(file) {
    let reader = new FileReader();

    reader.onload = function() {
      successCallback(reader.result);
    };

    reader.onerror = function() {
      errorCallback(reader.error);
    }

    reader.readAsText(file);
  }, errorCallback);
}
</pre>

<p>This function calls <code>file()</code>, specifying as its success callback a method which proceeds to use a {{domxref("FileReader")}} to read the file as text. The FileReader's {{event("load")}} event handler is set up to deliver the loaded string to the <code>successCallback</code> specified when the <code>readFile()</code> method was called; similarly, its {{event("error")}} handler is set up to call the <code>errorCallback</code> specified.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-filesystemfileentry-file', 'file()') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemFileEntry.file")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
</ul>
